# EnSimpleStaging  |  Copyright(C), 2004, Enfold Systems, LLC
# see LICENSE.txt for details

from Products.MenuGenerator.config import *
from Products.MenuGenerator.command import Command
from Products.MenuGenerator.node import Node
from Products.MenuGenerator.MenuTool import registerGenerator

exclude = {
    'Members': True,
    }

class PloneMapGenerator:
    ''' generator for a plone site map '''

    def getNodeTree(self, **kwargs):
        node = Node('root')
        root = kwargs['root']
        path = '/'.join(root.getPhysicalPath())
        node.data = Command(title=root.title_or_id(),
            icon=root.getIcon(),
            action=root.absolute_url(),
            relative_url=root.relative_url())
        brains = root.portal_catalog.searchResults(portal_type='Folder',
            path=path,
            sort_on='relative_url')
        brains = [b for b in brains]
        self.buildTree(node, brains)
        return node

    def buildTree(self, node, brains):
        data = node.data
        while len(brains):
            url = brains[0].relative_url
            exc = False
            for k in exclude.keys():
                if url.startswith(k):
                    brains.pop(0)
                    exc = True
                    break
            if exc:
                continue
            if node.name == 'root':
                self.addChild(node, data, brains)
            else:
                if url.startswith(data.relative_url):
                    self.addChild(node, data, brains)
                else:
                    break

    def addChild(self, node, data, brains):
        brain = brains.pop(0)
        title = brain.Title or brain.id
        child = node.addChild(brain.id, Command(title=title,
            icon=brain.getIcon,
            action=data['action']+'/'+brain.id,
            relative_url=brain.relative_url))
        self.buildTree(child, brains)

registerGenerator('workspace_sitemap', PloneMapGenerator)
