from StringIO import StringIO
from Products.MenuGenerator.command import *


class HTMLEmitter:
    """Emitter that produces a CSS tree
    """
    def __init__(self, buffer=None):
        if not buffer:
            self.buffer = StringIO()
            
    def getvalue(self):
        return self.buffer.getvalue()

    def read(self):
        return self.buffer.read()

    __call__ = getvalue
    
            
    def emit(self, command):
        emitter = getattr(self, "emit_%s" % command.type)
        emitter(command)


    def emit_Normal(self, command):
        print >>self.buffer, "<li>",
        if command.action:
            print >>self.buffer, '<a href="%(action)s" ' % command,
            if command.anchor:
                print >>self.buffer, 'name="%(anchor)s" ' % command,
            if command.id:
                print >>self.buffer, 'id="%(id)s" ' % command,
            if command.target:
                print >>self.buffer, 'target="%(target)s" ' % command,
            print >>self.buffer, ">", 

            if command.icon:
                print >>self.buffer, '<img src="%(icon)s" border=0> ' %command,
            
            
                
        print >>self.buffer, "%(title)s</li>" % command
        
    def emit_StartMenu(self, command):
        print >>self.buffer, "<ul>"

    def emit_EndMenu(self, command):
        print >>self.buffer, "</ul>"

    def emit_StartSubMenu(self, command):
        print >>self.buffer, '<ul class="menu">'


    emit_EndSubMenu = emit_EndMenu
    
        
