from StringIO import StringIO
from Products.MenuGenerator.MenuTool import registerEmitter
from Products.MenuGenerator.command import *
import sys

_marker = []

class MacroEmitter:
    """given the path to a template call its 'display_node' macro on the top level of the tree,
    the ME/TAL has to do the rest. the menu tool's getMenu must be
    called with using the following pattern:

    inside the macro the element 'tree' will be the top level node
    metal:use-macro="python: here.menu_tool.getMenu(name, asMacro=1, ...)"
    
    """
    
    def walkNodeTree(self, tree, template=None, **kwargs):
        # look for the context in the stack
        frame = sys._getframe()
        try:
            context = _marker
            while context is _marker and frame is not None:
                context = frame.f_locals.get('econtext', _marker)
                frame = frame.f_back
            if context is _marker:
                raise RuntimeError, 'Context not found'
        finally:
            del frame
            
        context.setLocal('tree', tree)
        macro = template.pt_macros()['display_node']
        return macro

        

registerEmitter('macro', MacroEmitter)
