from StringIO import StringIO
from Products.MenuGenerator.MenuTool import registerEmitter
from Products.MenuGenerator.command import *
import urlparse


class PloneNavEmitter:
    '''This is my second stab at an emitter for a Plone navigation
       menu and is based on HTMLEmitter.
       - swampmonkey'''
    def __init__(self, buffer=None):
        if not buffer:
            self.buffer = StringIO()
            
    def getvalue(self):
        return self.buffer.getvalue()

    def walkNodeTree(self, tree, **kwargs):
        tree.bfs(self.treeEmit, self.treeCloser, **kwargs)

    def treeEmit(self, node, **kwargs):
        command = node.data
        if command is None: return
        if node.parent is None:
            self.emit_Root(command, **kwargs)
        else:
            self.emit_Normal(command, **kwargs)
        if node.hasChildren():
            self.emit_StartMenu(command, **kwargs)
            

    def treeCloser(self, node, **kwargs):
        command = node.data
        if not command: return
        if node.hasChildren():
            self.emit_EndMenu(command, **kwargs)
            
    
    def emit(self, command):
        emitter = getattr(self, "emit_%s" % command.type)
        emitter(command)


    def emit_Normal(self, command, **kwargs):
        if not command.action: return
        path = urlparse.urlsplit(command.action)[2]
        entry = ('<li><a href="%s"><img src="%s"'
            ' height="16" width="16" />&nbsp;<span>%s</span>'
            '</a></li>')
        entry = entry % (command.action, command.icon, command.title)
        print >>self.buffer, entry

    def emit_Root(self, command, **kwargs):
        if not command.action: return
        entry = ('<a href="%s"><img src="%s" height="16" width="16" />'
            '&nbsp;<span>%s</span></a>')
        entry = entry % (command.action, command.icon, command.title)
        print >>self.buffer, entry

    def emit_StartMenu(self, command, **kwargs):
        print >>self.buffer, '<ul>'

    def emit_EndMenu(self, command, **kwargs):
        print >>self.buffer, '</ul>'

        
registerEmitter('default_plone_navigation', PloneNavEmitter)
