from StringIO import StringIO
from Products.MenuGenerator.MenuTool import registerEmitter
from Products.MenuGenerator.command import *


class ScriptEmitter:
    """Call a python script in the aq path, it should traverse the tree and produce the output.
    This just makes it a runtime/ZMI operation
    """
    
    def __init__(self, buffer=None):
        if not buffer:
            self.buffer = StringIO()
            
    def getvalue(self):
        return self.buffer.getvalue()

    def read(self):
        return self.buffer.read()

    __call__ = getvalue

    def walkNodeTree(self, tree, emitter=None, **kwargs):
        mt = kwargs.get('menu_tool')
        emitter(tree=tree, buffer=self.buffer)

registerEmitter('script', ScriptEmitter)
