from StringIO import StringIO
from Products.MenuGenerator.MenuTool import registerEmitter
from Products.MenuGenerator.command import *


class XMLEmitter:
    """Tree walk produces evaluated XML nodes
    """

    def getvalue(self):
        return self.buffer.getvalue()
    
    def walkNodeTree(self, tree, *args, **kwargs):
        self.buffer = StringIO()
        print >>self.buffer, '<?xml version="1.0" ?>'
        print >>self.buffer, '<menu>'
        tree.bfs(self.treeEmit, self.treeCloser)
        print >>self.buffer, '</menu>'
        
    def treeEmit(self, node):
        command = node.data
        if not command: return
        close = '/'
        if node.hasChildren(): close = ''
        self.write(node, '''<node%s%s>''' % (self._parts(node), close))

    def treeCloser(self, node):
        command = node.data
        if not command: return
        if node.hasChildren():
            self.write(node, '''</node>''')

    def write(self, node, msg):
        print >>self.buffer, " " * node.getDepth(),
        print >>self.buffer, msg
    
    def _parts(self, node):
        command = node.data
        attrs = []
        for k,v in command.items():
            attrs.append('''%s="%s"''' % (k,v))

        if attrs:
            attrs.insert(0, ' ')
        return ' '.join(attrs)


            
registerEmitter('xml', XMLEmitter)
