from __future__ import nested_scopes
from Acquisition import aq_base
from Products.CMFCore.utils import getToolByName
from Products.MenuGenerator.config import *
from Products.MenuGenerator.command import Command
from Products.MenuGenerator.node import Node
from Products.MenuGenerator.MenuTool import registerGenerator

TupleType = type(())
ListType = type([])

            
        
            
class MetaGen:
    def getNodeTree(self, **kwargs):
        return self._buildTree(kwargs['config'], kwargs['data'])
    
    def _buildTree(self, config, data):
        """Build a tree bottom up that can later be walked by 'walk' to emit commands"""
        tree = Node('root')
        values = {}

        def quickAsk(data, key):
            if values.has_key(key):
                return values[key]
            else:
                value = getattr(d, key, None)
                if not value: value = getattr(d, "get%s" % key, None)
                if callable(value): value = value()
                if value:
                    if type(value) not in [ListType, TupleType]:
                        value = (value,)

            values[key] = value
            return value

        def walk_tree(spec, node, data, values, showLevel=0):
            # print spec
            levelName = None
            if len(spec): levelName = spec[0]
            #Add in the level names? Makes a deep tree
            if levelName and showLevel: node = node.addChild([levelName])

            children = values.get(levelName)
            if not children: children = []
            for child in children:
                node = node.addChild(child)
                if spec[1:]:
                    node.data = Command(title=node.name)
                    walk_tree(spec[1:], node, data, values)
                else:
                    # print "added %s" % node
                    node.addChild([data.title_or_id()], Command(title=data.title_or_id(),
                                                                action=data.absolute_url()))
                    cmd = self.node2Command(node)
                    node.data = cmd
                    
                node = node.getParent()
                
        for d in data:
            #ask all the questions and place the element in the tree
            values.clear() #tmp value cache
            #quickly ask each question for all the questions for all the specs
            for spec in config:
                for layer in spec:
                    v = quickAsk(d, layer)

                # Now we need to pretend that there is a tree
                # where each level of the spec is a layer and
                # each _value_ is another branch or child.
                # When we can decend no further we place a node
                walk_tree(spec, tree, d, values)
            

        return tree

    def node2Command(self, node):
        isLeaf = node.isLeaf()
        entry = node.data
        if entry:
            cmd = Command(action=entry.absolute_url(), title=node.name, icon=entry.getIcon())
        else: #Its a submenu
            cmd = Command(title=node.name)
        return cmd


registerGenerator('metagen', MetaGen)
