from Acquisition import aq_base
from Products.MenuGenerator.config import *
from Products.MenuGenerator.command import Command
from Products.MenuGenerator.node import Node
from Products.MenuGenerator.MenuTool import registerGenerator

class OFSGenerator:
    def getNodeTree(self, **kwargs):
        node = Node('root')
        self.walk(kwargs['root'], node)
        return node
    
    def walk(self, root, node):
        ### XXX This is a demo and not intended for real use.
        contentValues = root.contentValues()
        for entry in contentValues:
            id = getattr(aq_base(entry), 'id', None)
            if not id or str(id).startswith('.'):
                continue # a kind of private
            
            iscontent = hasattr(aq_base(entry), 'isPortalContent')
            isfolder = hasattr(aq_base(entry), 'contentValues')
            hasIndex = hasattr(aq_base(entry), 'index_html')
            action = entry.absolute_url()
            if hasIndex:
                action = "%s/index_html" % action
            if entry.id == "index_html": continue
            
            child = node.addChild(entry.getId(), Command(title=entry.title_or_id(), icon=entry.getIcon(), action=action))
            if isfolder:
                self.walk(entry, child)
                
                
        
registerGenerator('ofs', OFSGenerator)
