from Products.MenuGenerator.MenuTool import registerGenerator
from Products.MenuGenerator.command import Command
from Products.MenuGenerator.config import *
from Products.MenuGenerator.node import Node
from fnmatch import fnmatch
import os
import os.path

class TreeGenerator:

    def getNodeTree(self, **kwargs):
        tree = Node('root')
        path = kwargs.get('path', '.')
        path = os.path.abspath(path)
        self.walk(path, tree)
        return tree
    
    def filter(self, names):
        names =[n for n in names if fnmatch(n, '*[!~]')]
        names =[n for n in names if n != 'CVS']
        return names
    
    def walk(self, path, node):
        dir = os.listdir(path)
        dir = self.filter(dir)
        for entry in dir:
            fpath = os.path.join(path, entry)
            isdir = os.path.isdir(fpath)
            isfile = os.path.isfile(fpath)
            node = node.addChild(entry, Command(action=fpath, title=entry))
            if isdir:
                self.walk(fpath, node)

    
registerGenerator('fsgen', TreeGenerator)
