from Acquisition import aq_base
from Products.MenuGenerator.config import *
from Products.MenuGenerator.node import Node
from Products.MenuGenerator.utils import StringExpression
from Products.MenuGenerator.command import Command
from StringIO import StringIO
from Products.MenuGenerator.MenuTool import registerGenerator

from parser import MenuHandler, parseString


class UltimateCommand(Command):
    """Command Object with defaults that should populate these menus a little better.
    Blame it on the UDM, blame JS, blame Canada
    """

    defaults = {
        'align_to_edge' : '',
        'text_alignment' : '',
        'v_offset' : 0,
        'h_offset' : 0,
        'filter' : '',

        'width' : 64, 

        'mCOLOR' : '#ffffff',
        'rCOLOR' : '',
        'aLINK'  : '',
        'aHOVER' : '',

        
        'alt_text'      : '',
        'top_position'  : 0,
        'left_position' : 0,
        'key_trigger'   : '',
        
        }
    
    def __getitem__(self, key):
        return self.data.get(key, self.getDefaultForKey(key))

    def getDefaultForKey(self, key):
        return self.defaults.get(key, '')
    
    

class XMLHandler(MenuHandler):
    #Node Handling methods
    def process(self, name, attrs):
        elementName = attrs.get('id', attrs.get('label', name))
        n = self.node = self.node.addChild(elementName)
        d = {}
        for k in attrs.keys():
            #Prep attributes as expressions
            d[str(k)] = StringExpression(attrs.getValue(k))

        #XXX nasty 
        if attrs.get('url') and not attrs.get('action'):
            d['action'] = d['url']

        d['type'] = name
        n.data = self.commandClass(**d) 

        
class UltimateGenerator:
    def getNodeTree(self, data, context=None, *args, **kwargs):
        commandClass = kwargs.get('commandClass', Command)
        m = XMLHandler(commandClass)
        parseString(data, m)
        tree = m.getTree()

        #Eval an attributes in context
        def eval_attrs(node, context=context):
            command = node.data
            if not command: return
            for k in command.keys():
                expr = command.get(k)
                if expr and isinstance(expr, StringExpression):
                    v = expr(context)
                    #replace the expression with the value
                    #we could override str in the expr at this point too
                    command.set(k, v)

        tree.bfs(eval_attrs)
        return tree
    
