from xml.sax.handler import ContentHandler
from xml.sax import parseString

from Products.MenuGenerator.node import Node



class MenuHandler(ContentHandler):
    def __init__(self, tree, commandClass):
        ContentHandler.__init__(self)
        self.commandClass = commandClass
        self.node = tree
        
    def startElement(self, name, attrs):
        #dispatch
        method = getattr(self, "process_%s" % name, None)
        if method:
            method(attrs)
        else:
            self.process(name, attrs)

    def endElement(self, name):
        self.node = self.node.getParent()


    def process(self, name, attrs):
        pass
    
    
## #Non leaky older parser, slow and sad
## from xmllib import XMLParser

## class MenuHandler(XMLParser):
##     def __init__(self, commandClass):
##         XMLParser.__init__(self)
##         self.tree = self.node = Node('menu')
##         self.commandClass = commandClass
        
        
##     def unknown_starttag(self, name, attrs):
##         method = getattr(self, "process_%s" % name, None)
##         if method:
##             method(attrs)
##         else:
##             self.process(name, attrs)


            
##     def unknown_endtag(self, tag):
##         self.node = self.node.getParent()

##     def getTree(self):
##         v = self.tree
##         del self.node
##         del self.tree
##         del self.commandClass
##         return v

##     def process(self, name, attrs):
##         pass
    
