import unittest
from Products.MenuGenerator.config import *
from Products.MenuGenerator.MenuTool import MenuTool
from Products.MenuGenerator.emitters import HTMLEmitter, TreeMenuEmitter, BrainJarEmitter, GazingusEmitter
from Products.MenuGenerator.command import Command
from Products.MenuGenerator.generators import TreeGenerator, OFSGenerator
from difflib import SequenceMatcher
from os.path import dirname, abspath, join
from os import curdir

try:
    # Test was called by another test.
    _prefix = abspath(dirname(__file__))
except NameError:
    # Test was called directly, so no __file__ global exists.
    _prefix = abspath(curdir)


prefix = _prefix


def validate(input, output):
    outputValue = open(join(_prefix, 'output', output), 'r').read().strip()
    try:
        sm = SequenceMatcher(lambda x: x in [' ', '\t'], input, outputValue)
        r = sm.ratio()
        assert r >= 0.90
    except AssertionError:
        name = join(_prefix, 'output', "%s.fail" % output)
        fp = open(name, 'w')
        print >>fp, outputValue
        fp.close()
        raise AssertionError("Input didn't match expected output, see %s for details" % name)
    

def save(input, output):
    fp = open(join(_prefix, 'output', output), 'w')
    print >>fp, input
    fp.close()
    
