""" 
Unit tests for the backend emitter code

$Id: test_producer.py,v 1.1.1.1 2003/08/12 22:40:27 runyaga Exp $
"""

import unittest
import Zope

try:
    Zope.startup()
except: # Zope > 2.6
    pass


from rigging import *


class ProducerTests(unittest.TestCase):
    def test_TreeMenu(self):
        tree = TreeMenuEmitter()
        p    = Producer(tree)
        
        commands = [
            Command(type=START_MENU),

            Command(action='http://foo.bar/',
                    title="Test Link",
                    type=NORMAL_MENU,
                    ),

            Command(type=START_SUBMENU),

            Command(action='http://foo.com/',
                    title="Test Link2",
                    type=NORMAL_MENU,
                    ),

            Command(type=END_SUBMENU),
            
            Command(type=END_MENU),
            ]

        
        p.feed(commands)
        validate(input=p(), output="testTree.out")

        
        
def test_suite():
    suite = unittest.TestSuite()
    suite.addTest( unittest.makeSuite( ProducerTests ) )
    return suite

if __name__ == '__main__':
    unittest.main( defaultTest = 'test_suite' )
