""" 
Unit tests for complete menu tool bound to CMF Site

$Id: test_tool.py,v 1.1.1.2 2003/10/07 14:31:00 bcsaller Exp $
"""

import unittest
import Zope

try:
    Zope.startup()
except: # Zope > 2.6
    pass

from Acquisition import aq_base
from Products.CMFCore.tests.base.testcase import SecurityRequestTest

from Products.MenuGenerator.config import *
from Products.MenuGenerator.public import *
from Products.MenuGenerator.MenuTool import MenuTool, registerGenerator, registerEmitter, registerMenu
from rigging import *


class MenuToolTests(SecurityRequestTest):
    def setUp(self):
        SecurityRequestTest.setUp(self)
        self.root.manage_addProduct[ 'CMFPlone' ].manage_addSite( 'testsite',)
                                                                 
        site = getattr(self.root, 'testsite')
        menu = MenuTool(TOOL_TITLE)
        site._setObject(TOOL_NAME, menu)
        registerGenerator('ofs', OFSGenerator)
        registerEmitter('tree', TreeMenuEmitter)
        registerMenu('test', 'ofs', 'tree')
        
    def test_getset(self):
        site = self.root.testsite
        mt = site.menu_tool

        out = mt.getMenu('test', root=site)
        validate(out, "ofsdefault.out")
 

def test_suite():
    suite = unittest.TestSuite()
    suite.addTest( unittest.makeSuite( MenuToolTests ) )
    return suite

if __name__ == '__main__':
    unittest.main( defaultTest = 'test_suite' )
