""" 
Unit tests for the input generation code

$Id: test_treegen.py,v 1.1.1.2 2003/10/07 14:31:00 bcsaller Exp $
"""

import unittest
import Zope


try:
    Zope.startup()
except: # Zope > 2.6
    pass

from Products.MenuGenerator.generators.XMLConfig import XMLHandler, XMLGenerator
from rigging import *

sample_data = """
<menu name="testMenu">
   <node title="File" id="file_menu">
      <node title="Open" action="${portal_url/absolute_url}/open" id="open">
         <node title="Open Foo" onclick="alert(event)" action="${portal_url/absolute_url}/open?foo"/>
         <node title="Open Bar" action="${portal_url/absolute_url}/open?bar"/>
      </node>
      <node title="Exit" action="http://yahoo.com/"/>
   </node>
   <node title="Help" action="${portal_url/absolute_url}/help" id="help"/>
</menu>
"""


class TreeGenTests(unittest.TestCase):
    def test_TreeMenu(self):
        em = TreeMenuEmitter()
        tg   = TreeGenerator()
        tree = tg.getNodeTree(path=join(prefix, "input"))

        em.walkNodeTree(tree)
        text  = em.getvalue()

        validate(input=text, output="testTreeGen.out")

    def testXmlSource(self):
        em = TreeMenuEmitter()
        gen = XMLGenerator()

        context = {
            'portal_url' : { 'absolute_url' : 'http://testsite.com' },
            }
        
        tree = gen.getNodeTree(sample_data, context)
        em.walkNodeTree(tree)
        text = em.getvalue()
        validate(input=text, output="xml_to_treeem.out")
        

        
        
def test_suite():
    suite = unittest.TestSuite()
    suite.addTest( unittest.makeSuite( TreeGenTests ) )
    return suite

if __name__ == '__main__':
    unittest.main( defaultTest = 'test_suite' )
