""" 
test the xml parser/generator

$Id: test_ultimate.py,v 1.1.1.1 2003/08/12 22:40:27 runyaga Exp $
"""

import Zope

try:
    Zope.startup()
except: # Zope > 2.6
    pass


from Products.MenuGenerator.tests.rigging import *
from Products.MenuGenerator.generators.UltimateGenerator import XMLHandler, UltimateGenerator, UltimateCommand
from Products.MenuGenerator.generators import XMLGenerator
from Products.MenuGenerator.emitters import UltimateEmitter
from Products.MenuGenerator.command import Command

from xml.sax import parseString


sample_data = """
<topMenu>
  <menuItem label="&lt;span class='u'&gt;A&lt;/span&gt;bout the Company" action="${portal_url}/company" width="161" text_alignment="center" top_position="0" left_position="0" key_trigger="a">

  <subMenu width="192" align_to_edge="left" text_alignment="left" v_offset="-4" h_offset="0">
     <menuItem label="Liquidnet Senior Management" action="${portal_url}/company/LN_Senior_Management"/>
     <menuItem label="Liquidnet Board of Directors" action="${portal_url}/company/LN_Board_of_Directors"/>
     <menuItem label="Liquidnet Europe" action="${portal_url}/company/LN_Europe"/>
  </subMenu>

  </menuItem>


  <menuItem label="&lt;span class='u'&gt;H&lt;/span&gt;ow Liqidnet Works" action="${portal_url}/how" width="163" text_alignment="center" top_position="0" left_position="0" key_trigger="h">
  <subMenu width="194" align_to_edge="left" text_alignment="left" v_offset="-4" h_offset="0">
     <menuItem label="Products Features and Benefits" action="${portal_url}/how/Product_Features_and_Benefits"/>
     <menuItem label="Liquidnet FAQ" action="${portal_url}/how/LN_FAQ"/>
     <menuItem label="Soft Dollar Program" action="${portal_url}/how/Soft_Dollar_Program"/>
  </subMenu> 
  </menuItem>

  <menuItem label="About Liquidnet &lt;span class='u'&gt;M&lt;/span&gt;embership" action="${portal_url}/membership" width="160" text_alignment="center" top_position="0" left_position="0" key_trigger="m">
  <subMenu width="190" align_to_edge="left" text_alignment="left" v_offset="-4" h_offset="0">
     <menuItem label="Membership Benefits >>" action="${portal_url}/membership/Membership_Benefits">
     <subMenu width="190" align_to_edge="left" text_alignment="left" v_offset="-4" h_offset="0">
        <menuItem label="Market Impact Cost Analysis" action="${portal_url}/membership/Market_Analysis"/>		
     </subMenu>     
     </menuItem>
     <menuItem label="Information Request Form" action="${portal_url}/membership/Info_Request"/>

  </subMenu>
  </menuItem>

  <menuItem label="&lt;span class='u'&gt;N&lt;/span&gt;ews &amp; Statistics" action="${portal_url}/news" width="120" text_alignment="center" top_position="0" left_position="0" key_trigger="n">
  <subMenu width="190" align_to_edge="left" text_alignment="left" v_offset="-4" h_offset="0">
        <menuItem label="Press Releases" action="${portal_url}/news/Press_Releases"/>		
        <menuItem label="Liquidnet In the News" action="${portal_url}/news/LN_in_News"/>		
  </subMenu>
  </menuItem>

  <menuItem label="&lt;span class='u'&gt;C&lt;/span&gt;areers" action="${portal_url}/careers" width="160" text_alignment="center" top_position="0" left_position="0" key_trigger="c"/>

  <menuItem label="&lt;span class='u'&gt;A&lt;/span&gt;bout the Company" action="${portal_url}/contact" width="160" text_alignment="center" top_position="0" left_position="0" key_trigger="a"/>

</topMenu>


"""


node_data = """
<menu name="testMenu">
   <node title="File" id="file_menu">
      <node title="Open" action="${portal_url/absolute_url}/open" id="open">
         <node title="Open Foo" onclick="alert(event)" action="${portal_url/absolute_url}/open?foo"/>
         <node title="Open Bar" action="${portal_url/absolute_url}/open?bar"/>
      </node>
      <node title="Exit" action="http://yahoo.com/"/>
   </node>
   <node title="Help" action="${portal_url/absolute_url}/help" id="help"/>
</menu>
"""


class UltimateTests(unittest.TestCase):
    def test_parser(self):
        m = XMLHandler(Command)
        parseString(sample_data, m)
        tree = m.getTree()


    def test_ultimate(self):
        e = UltimateEmitter()
        x = UltimateGenerator()

        context = {
            'portal_url' : 'http://testsite.com' ,
            }
            
        tree = x.getNodeTree(sample_data, context)
        e.walkNodeTree(tree)
        assert e.getvalue()

    def test_xml_udm(self):
        e = UltimateEmitter()
        x = XMLGenerator()

        context = {
            'portal_url' : { 'absolute_url' : 'http://testsite.com' },
            }

        tree = x.getNodeTree(node_data, context, commandClass=UltimateCommand)
        e.walkNodeTree(tree)
        assert e.getvalue()

    def test_xml_udm_top(self):
        e = UltimateEmitter()
        x = XMLGenerator()

        context = {
            'portal_url' : { 'absolute_url' : 'http://testsite.com' },
            }

        tree = x.getNodeTree(node_data, context, commandClass=UltimateCommand)
        e.walkNodeTree(tree, mode="top")
        assert e.getvalue()





 
def test_suite():
    suite = unittest.TestSuite()
    suite.addTest(unittest.makeSuite(UltimateTests))
    return suite

if __name__ == '__main__':
    unittest.main( defaultTest = 'test_suite' )
