""" 
test the xml parser/generator

$Id: test_xml.py,v 1.1.1.2 2003/10/07 14:31:00 bcsaller Exp $
"""

import Zope

try:
    Zope.startup()
except: # Zope > 2.6
    pass


from Products.MenuGenerator.tests.rigging import *
from Products.MenuGenerator.generators.XMLConfig import XMLHandler, XMLGenerator
from Products.MenuGenerator.emitters import BrainJarEmitter, XMLEmitter
from Products.MenuGenerator.command import Command
from Products.MenuGenerator.node import Node
from xml.sax import parseString


sample_data = """
<menu name="testMenu">
   <node title="File" id="file_menu">
      <node title="Open" action="${portal_url/absolute_url}/open" id="open">
         <node title="Open Foo" onclick="alert(event)" action="${portal_url/absolute_url}/open?foo"/>
         <node title="Open Bar" action="${portal_url/absolute_url}/open?bar"/>
      </node>
      <node title="Exit" action="http://yahoo.com/"/>
   </node>
   <node title="Help" action="${portal_url/absolute_url}/help" id="help"/>
</menu>
"""

class XMLTests(unittest.TestCase):
    def test_parser(self):
        tree = Node('menu')
        m = XMLHandler(tree, Command)
        parseString(sample_data, m)

        assert tree.file_menu.open

    def test_brainjar(self):
        e = BrainJarEmitter()
        x = XMLGenerator()

        context = {
            'portal_url' : { 'absolute_url' : 'http://testsite.com' },
            }
            
        tree = x.getNodeTree(sample_data, context)
        e.walkNodeTree(tree)
        validate(input=e.getvalue(), output="brainjar.out")
        

    def test_gazingus(self):
        e = GazingusEmitter()
        x = XMLGenerator()

        context = {
            'portal_url' : { 'absolute_url' : 'http://testsite.com' },
            }
            
        tree = x.getNodeTree(sample_data, context)
        e.walkNodeTree(tree)
        validate(input=e.getvalue(), output="gazingus.out")


    def test_xmlemit(self):
        e = XMLEmitter()
        x = XMLGenerator()

        context = {
            'portal_url' : { 'absolute_url' : 'http://testsite.com' },
            }
            
        tree = x.getNodeTree(sample_data, context)
        e.walkNodeTree(tree)
        assert e.getvalue()
        

    def test_current(self):
        e = XMLEmitter()
        x = XMLGenerator()

        context = {
            'portal_url' : { 'absolute_url' : 'http://testsite.com' },
            }
            
        tree = x.getNodeTree(sample_data, context, current="http://testsite.com/help")
        e.walkNodeTree(tree)
        
        v = e.getvalue()
        validate(input=v, output="xml_current.out")

        
 
def test_suite():
    suite = unittest.TestSuite()
    suite.addTest(unittest.makeSuite(XMLTests))
    return suite

if __name__ == '__main__':
    unittest.main( defaultTest = 'test_suite' )
