##############################################################################
#
# Enfold Stage Deployment - Remote Deployment of Staged Content
# Copyright (C) 2005 Enfold Systems
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
##############################################################################
"""
$Id: patch.py 1324 2005-03-31 21:15:10Z sidnei $
"""

from Products.Archetypes.utils import wrap_method
from Products.EnSimpleStaging.content.stage import StagingArea
from Products.StageDeployment.event import publishLastChangedEvent
from Products.StageDeployment.event import publishStageEvent

def publishLastChanged(self, *args, **kw):
    ret = call(self, 'publishLastChanged', *args, **kw)
    publishLastChangedEvent(self)
    return ret

def publishStage(self, *args, **kw):
    ret = call(self, 'publishStage', *args, **kw)
    publishStageEvent(self)
    return ret

PATTERN = '__StageDeployment_%s__'
def call(self, __name__, *args, **kw):
    return getattr(self, PATTERN % __name__)(*args, **kw)

wrap_method(StagingArea, 'publishLastChanged',
            publishLastChanged, pattern=PATTERN)

wrap_method(StagingArea, 'publishStage', publishStage, pattern=PATTERN)
