#
# Runs all tests in the current directory
#
# Execute like:
#   python runalltests.py
#
# Alternatively use the testrunner:
#   python /path/to/Zope/utilities/testrunner.py -qa
#

import os, sys
from os.path import dirname, realpath
import unittest
suite = unittest.TestSuite()

parent = dirname(dirname(realpath(__file__)))
if not parent in sys.path:
    sys.path.insert(0, parent)

tests = os.listdir(dirname(realpath(__file__)))
tests = [n[:-3] for n in tests if n.startswith('test') and n.endswith('.py')]

for test in tests:
    m = __import__(test)
    if hasattr(m, 'test_suite'):
        suite.addTest(m.test_suite())

if __name__ == '__main__':
    unittest.TextTestRunner().run(suite)
